diff -ruN vdr-1.5.9/dvbsubtitle.h vdr-1.5.10/dvbsubtitle.h
--- vdr-1.5.9/dvbsubtitle.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.10/dvbsubtitle.h	2007-10-14 16:02:46.000000000 +0200
@@ -0,0 +1,43 @@
+/*
+ * dvbsubtitle.h: DVB subtitles
+ *
+ * See the main source file 'vdr.c' for copyright information and
+ * how to reach the author.
+ *
+ * Original author: Marco Schlüßler <marco@lordzodiac.de>
+ *
+ * $Id: dvbsubtitle.h 1.1 2007/10/14 14:02:46 kls Exp $
+ */
+
+#ifndef __DVBSUBTITLE_H
+#define __DVBSUBTITLE_H
+
+#include "osd.h"
+#include "thread.h"
+#include "tools.h"
+
+class cDvbSubtitlePage;
+class cDvbSubtitleAssembler;
+class cDvbSubtitleBitmaps;
+
+class cDvbSubtitleConverter : public cThread {
+private:
+  static int setupLevel;
+  cDvbSubtitleAssembler *dvbSubtitleAssembler;
+  cOsd *osd;
+  cList<cDvbSubtitlePage> *pages;
+  cList<cDvbSubtitleBitmaps> *bitmaps;
+  tColor yuv2rgb(int Y, int Cb, int Cr);
+  bool AssertOsd(void);
+  int ExtractSegment(const uchar *Data, int Length, int64_t Pts);
+  void FinishPage(cDvbSubtitlePage *Page);
+public:
+  cDvbSubtitleConverter(void);
+  virtual ~cDvbSubtitleConverter();
+  void Action(void);
+  void Reset(void);
+  int Convert(const uchar *Data, int Length);
+  static void SetupChanged(void);
+  };
+
+#endif //__DVBSUBTITLE_H
diff -ruN vdr-1.5.9/eit.c vdr-1.5.10/eit.c
--- vdr-1.5.9/eit.c	2007-07-28 15:16:43.000000000 +0200
+++ vdr-1.5.10/eit.c	2007-08-26 12:56:33.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 1.125 2007/07/28 13:16:43 kls Exp $
+ * $Id: eit.c 1.126 2007/08/26 10:56:33 kls Exp $
  */
 
 #include "eit.h"
@@ -219,11 +219,11 @@
                  SI::ComponentDescriptor *cd = (SI::ComponentDescriptor *)d;
                  uchar Stream = cd->getStreamContent();
                  uchar Type = cd->getComponentType();
-                 if (1 <= Stream && Stream <= 2 && Type != 0) {
+                 if (1 <= Stream && Stream <= 3 && Type != 0) { // 1=video, 2=audio, 3=subtitles
                     if (!Components)
                        Components = new cComponents;
                     char buffer[Utf8BufSize(256)];
-                    Components->SetComponent(Components->NumComponents(), cd->getStreamContent(), cd->getComponentType(), I18nNormalizeLanguageCode(cd->languageCode), cd->description.getText(buffer, sizeof(buffer)));
+                    Components->SetComponent(Components->NumComponents(), Stream, Type, I18nNormalizeLanguageCode(cd->languageCode), cd->description.getText(buffer, sizeof(buffer)));
                     }
                  }
                  break;
diff -ruN vdr-1.5.9/i18n-to-gettext.pl vdr-1.5.10/i18n-to-gettext.pl
--- vdr-1.5.9/i18n-to-gettext.pl	2007-08-24 15:19:34.000000000 +0200
+++ vdr-1.5.10/i18n-to-gettext.pl	2007-10-14 16:14:22.000000000 +0200
@@ -10,7 +10,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: i18n-to-gettext.pl 1.4 2007/08/24 13:19:34 kls Exp $
+# $Id: i18n-to-gettext.pl 1.5 2007/10/14 14:14:22 kls Exp $
 
 # How to convert an actual plugin:
 #
@@ -319,7 +319,7 @@
 $(I18Npo): $(I18Npot)
 	msgmerge -U --no-wrap -F --backup=none -q $@ $<
 
-i18n: $(I18Nmo)
+i18n: $(I18Npot) $(I18Nmo)
 	@mkdir -p $(LOCALEDIR)
 	for i in $(I18Ndirs); do\
 	    mkdir -p $(LOCALEDIR)/$$i/LC_MESSAGES;\
diff -ruN vdr-1.5.9/keys.c vdr-1.5.10/keys.c
--- vdr-1.5.9/keys.c	2007-08-11 13:30:18.000000000 +0200
+++ vdr-1.5.10/keys.c	2007-08-26 14:35:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: keys.c 1.15 2007/08/11 11:30:18 kls Exp $
+ * $Id: keys.c 1.16 2007/08/26 12:35:21 kls Exp $
  */
 
 #include "keys.h"
@@ -49,6 +49,7 @@
                     { kVolDn,         trNOOP("Key$Volume-")     },
                     { kMute,          trNOOP("Key$Mute")        },
                     { kAudio,         trNOOP("Key$Audio")       },
+                    { kSubtitles,     trNOOP("Key$Subtitles")   },
                     { kSchedule,      trNOOP("Key$Schedule")    },
                     { kChannels,      trNOOP("Key$Channels")    },
                     { kTimers,        trNOOP("Key$Timers")      },
diff -ruN vdr-1.5.9/keys.h vdr-1.5.10/keys.h
--- vdr-1.5.9/keys.h	2007-08-24 15:15:48.000000000 +0200
+++ vdr-1.5.10/keys.h	2007-08-26 14:34:50.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: keys.h 1.13 2007/08/24 13:15:48 kls Exp $
+ * $Id: keys.h 1.14 2007/08/26 12:34:50 kls Exp $
  */
 
 #ifndef __KEYS_H
@@ -43,6 +43,7 @@
              kVolDn,
              kMute,
              kAudio,
+             kSubtitles,
              kSchedule,
              kChannels,
              kTimers,
diff -ruN vdr-1.5.9/menu.c vdr-1.5.10/menu.c
--- vdr-1.5.9/menu.c	2007-08-24 15:15:48.000000000 +0200
+++ vdr-1.5.10/menu.c	2007-10-13 12:10:20.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.461 2007/08/24 13:15:48 kls Exp $
+ * $Id: menu.c 1.463 2007/10/13 10:10:20 kls Exp $
  */
 
 #include "menu.h"
@@ -260,6 +260,8 @@
   Add(new cMenuEditIntItem( tr("Apid2"),        &data.apids[1], 0, 0x1FFF));
   Add(new cMenuEditIntItem( tr("Dpid1"),        &data.dpids[0], 0, 0x1FFF));
   Add(new cMenuEditIntItem( tr("Dpid2"),        &data.dpids[1], 0, 0x1FFF));
+  Add(new cMenuEditIntItem( tr("Spid1"),        &data.spids[0], 0, 0x1FFF));
+  Add(new cMenuEditIntItem( tr("Spid2"),        &data.spids[1], 0, 0x1FFF));
   Add(new cMenuEditIntItem( tr("Tpid"),         &data.tpid,  0, 0x1FFF));
   Add(new cMenuEditCaItem(  tr("CA"),           &data.caids[0]));
   Add(new cMenuEditIntItem( tr("Sid"),          &data.sid, 1, 0xFFFF));
@@ -523,6 +525,7 @@
         Channels.Del(channel);
         cOsdMenu::Del(Index);
         Propagate();
+        Channels.SetModified(true);
         isyslog("channel %d deleted", DeletedChannel);
         if (CurrentChannel && CurrentChannel->Number() != CurrentChannelNr) {
            if (!cDevice::PrimaryDevice()->Replaying() || cDevice::PrimaryDevice()->Transferring())
@@ -547,6 +550,7 @@
      Channels.Move(FromChannel, ToChannel);
      cOsdMenu::Move(From, To);
      Propagate();
+     Channels.SetModified(true);
      isyslog("channel %d moved to %d", FromNumber, ToNumber);
      if (CurrentChannel && CurrentChannel->Number() != CurrentChannelNr) {
         if (!cDevice::PrimaryDevice()->Replaying() || cDevice::PrimaryDevice()->Transferring())
@@ -2400,6 +2404,8 @@
 private:
   int originalNumAudioLanguages;
   int numAudioLanguages;
+  int originalNumSubtitleLanguages;
+  int numSubtitleLanguages;
   void Setup(void);
   const char *videoDisplayFormatTexts[3];
   const char *updateChannelsTexts[6];
@@ -2412,7 +2418,10 @@
 {
   for (numAudioLanguages = 0; numAudioLanguages < I18nLanguages()->Size() && data.AudioLanguages[numAudioLanguages] >= 0; numAudioLanguages++)
       ;
+  for (numSubtitleLanguages = 0; numSubtitleLanguages < I18nLanguages()->Size() && data.SubtitleLanguages[numSubtitleLanguages] >= 0; numSubtitleLanguages++)
+      ;
   originalNumAudioLanguages = numAudioLanguages;
+  originalNumSubtitleLanguages = numSubtitleLanguages;
   videoDisplayFormatTexts[0] = tr("pan&scan");
   videoDisplayFormatTexts[1] = tr("letterbox");
   videoDisplayFormatTexts[2] = tr("center cut out");
@@ -2442,6 +2451,15 @@
   Add(new cMenuEditIntItem( tr("Setup.DVB$Audio languages"),       &numAudioLanguages, 0, I18nLanguages()->Size()));
   for (int i = 0; i < numAudioLanguages; i++)
       Add(new cMenuEditStraItem(tr("Setup.DVB$Audio language"),    &data.AudioLanguages[i], I18nLanguages()->Size(), &I18nLanguages()->At(0)));
+  Add(new cMenuEditBoolItem(tr("Setup.DVB$Display subtitles"),     &data.DisplaySubtitles));
+  if (data.DisplaySubtitles) {
+     Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle languages"),    &numSubtitleLanguages, 0, I18nLanguages()->Size()));
+     for (int i = 0; i < numSubtitleLanguages; i++)
+         Add(new cMenuEditStraItem(tr("Setup.DVB$Subtitle language"), &data.SubtitleLanguages[i], I18nLanguages()->Size(), &I18nLanguages()->At(0)));
+     Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle offset"),                  &data.SubtitleOffset,       -50, 50));
+     Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle foreground transparency"), &data.SubtitleFgTransparency, 0, 9));
+     Add(new cMenuEditIntItem( tr("Setup.DVB$Subtitle background transparency"), &data.SubtitleBgTransparency, 0, 10));
+     }
 
   SetCurrent(Get(current));
   Display();
@@ -2453,11 +2471,15 @@
   int oldVideoDisplayFormat = ::Setup.VideoDisplayFormat;
   bool oldVideoFormat = ::Setup.VideoFormat;
   bool newVideoFormat = data.VideoFormat;
+  bool oldDisplaySubtitles = ::Setup.DisplaySubtitles;
+  bool newDisplaySubtitles = data.DisplaySubtitles;
   int oldnumAudioLanguages = numAudioLanguages;
+  int oldnumSubtitleLanguages = numSubtitleLanguages;
   eOSState state = cMenuSetupBase::ProcessKey(Key);
 
   if (Key != kNone) {
      bool DoSetup = data.VideoFormat != newVideoFormat;
+     DoSetup |= data.DisplaySubtitles != newDisplaySubtitles;
      if (numAudioLanguages != oldnumAudioLanguages) {
         for (int i = oldnumAudioLanguages; i < numAudioLanguages; i++) {
             data.AudioLanguages[i] = 0;
@@ -2476,6 +2498,24 @@
         data.AudioLanguages[numAudioLanguages] = -1;
         DoSetup = true;
         }
+     if (numSubtitleLanguages != oldnumSubtitleLanguages) {
+        for (int i = oldnumSubtitleLanguages; i < numSubtitleLanguages; i++) {
+            data.SubtitleLanguages[i] = 0;
+            for (int l = 0; l < I18nLanguages()->Size(); l++) {
+                int k;
+                for (k = 0; k < oldnumSubtitleLanguages; k++) {
+                    if (data.SubtitleLanguages[k] == l)
+                       break;
+                    }
+                if (k >= oldnumSubtitleLanguages) {
+                   data.SubtitleLanguages[i] = l;
+                   break;
+                   }
+                }
+            }
+        data.SubtitleLanguages[numSubtitleLanguages] = -1;
+        DoSetup = true;
+        }
      if (DoSetup)
         Setup();
      }
@@ -2486,6 +2526,9 @@
         cDevice::PrimaryDevice()->SetVideoDisplayFormat(eVideoDisplayFormat(::Setup.VideoDisplayFormat));
      if (::Setup.VideoFormat != oldVideoFormat)
         cDevice::PrimaryDevice()->SetVideoFormat(::Setup.VideoFormat);
+     if (::Setup.DisplaySubtitles != oldDisplaySubtitles)
+        cDevice::PrimaryDevice()->EnsureSubtitleTrack();
+     cDvbSubtitleConverter::SetupChanged();
      }
   return state;
 }
@@ -3128,14 +3171,18 @@
   if (Components) {
      int indexAudio = 0;
      int indexDolby = 0;
+     int indexSubtitle = 0;
      for (int i = 0; i < Components->NumComponents(); i++) {
          const tComponent *p = Components->Component(i);
-         if (p->stream == 2) {
-            if (p->type == 0x05)
-               cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, indexDolby++, 0, LiveChannel ? NULL : p->language, p->description);
-            else
-               cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, indexAudio++, 0, LiveChannel ? NULL : p->language, p->description);
-            }
+         switch (p->stream) {
+           case 2: if (p->type == 0x05)
+                      cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, indexDolby++, 0, LiveChannel ? NULL : p->language, p->description);
+                   else
+                      cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, indexAudio++, 0, LiveChannel ? NULL : p->language, p->description);
+                   break;
+           case 3: cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, indexSubtitle++, 0, LiveChannel ? NULL : p->language, p->description);
+                   break;
+           }
          }
      }
 }
@@ -3491,7 +3538,7 @@
          numTracks++;
          }
       }
-  descriptions[numTracks] = 0;
+  descriptions[numTracks] = NULL;
   timeout.Set(TRACKTIMEOUT);
   displayTracks = Skins.Current()->DisplayTracks(tr("Button$Audio"), numTracks, descriptions);
   Show();
@@ -3569,7 +3616,7 @@
          timeout.Set(TRACKTIMEOUT);
          break;
     case kOk:
-         if (track != cDevice::PrimaryDevice()->GetCurrentAudioTrack())
+         if (types[track] != cDevice::PrimaryDevice()->GetCurrentAudioTrack())
             oldTrack = -1; // make sure we explicitly switch to that track
          timeout.Set();
          break;
@@ -3588,6 +3635,105 @@
   return timeout.TimedOut() ? osEnd : osContinue;
 }
 
+// --- cDisplaySubtitleTracks ------------------------------------------------
+
+cDisplaySubtitleTracks *cDisplaySubtitleTracks::currentDisplayTracks = NULL;
+
+cDisplaySubtitleTracks::cDisplaySubtitleTracks(void)
+:cOsdObject(true)
+{
+  SetTrackDescriptions(!cDevice::PrimaryDevice()->Replaying() || cDevice::PrimaryDevice()->Transferring() ? cDevice::CurrentChannel() : 0);
+  currentDisplayTracks = this;
+  numTracks = track = 0;
+  types[numTracks] = ttNone;
+  descriptions[numTracks] = strdup(tr("No subtitles"));
+  numTracks++;
+  eTrackType CurrentSubtitleTrack = cDevice::PrimaryDevice()->GetCurrentSubtitleTrack();
+  for (int i = ttSubtitleFirst; i <= ttSubtitleLast; i++) {
+      const tTrackId *TrackId = cDevice::PrimaryDevice()->GetTrack(eTrackType(i));
+      if (TrackId && TrackId->id) {
+         types[numTracks] = eTrackType(i);
+         descriptions[numTracks] = strdup(*TrackId->description ? TrackId->description : *TrackId->language ? TrackId->language : *itoa(i));
+         if (i == CurrentSubtitleTrack)
+            track = numTracks;
+         numTracks++;
+         }
+      }
+  descriptions[numTracks] = NULL;
+  timeout.Set(TRACKTIMEOUT);
+  displayTracks = Skins.Current()->DisplayTracks(tr("Button$Subtitles"), numTracks, descriptions);
+  Show();
+}
+
+cDisplaySubtitleTracks::~cDisplaySubtitleTracks()
+{
+  delete displayTracks;
+  currentDisplayTracks = NULL;
+  for (int i = 0; i < numTracks; i++)
+      free(descriptions[i]);
+  cStatus::MsgOsdClear();
+}
+
+void cDisplaySubtitleTracks::Show(void)
+{
+  displayTracks->SetTrack(track, descriptions);
+  displayTracks->Flush();
+  //cStatus::MsgSetSubtitleTrack(track, descriptions); //TODO better make a more general cStatus::MsgSetTrack(tr("Subtitles"), track, descriptions)
+}
+
+cDisplaySubtitleTracks *cDisplaySubtitleTracks::Create(void)
+{
+  if (cDevice::PrimaryDevice()->NumSubtitleTracks() > 0) {
+     if (!currentDisplayTracks)
+        new cDisplaySubtitleTracks;
+     return currentDisplayTracks;
+     }
+  Skins.Message(mtWarning, tr("No subtitles available!"));
+  return NULL;
+}
+
+void cDisplaySubtitleTracks::Process(eKeys Key)
+{
+  if (currentDisplayTracks)
+     currentDisplayTracks->ProcessKey(Key);
+}
+
+eOSState cDisplaySubtitleTracks::ProcessKey(eKeys Key)
+{
+  int oldTrack = track;
+  switch (Key) {
+    case kUp|k_Repeat:
+    case kUp:
+    case kDown|k_Repeat:
+    case kDown:
+         if (NORMALKEY(Key) == kUp && track > 0)
+            track--;
+         else if (NORMALKEY(Key) == kDown && track < numTracks - 1)
+            track++;
+         timeout.Set(TRACKTIMEOUT);
+         break;
+    case kSubtitles|k_Repeat:
+    case kSubtitles:
+         if (++track >= numTracks)
+            track = 0;
+         timeout.Set(TRACKTIMEOUT);
+         break;
+    case kOk:
+         if (types[track] != cDevice::PrimaryDevice()->GetCurrentSubtitleTrack())
+            oldTrack = -1; // make sure we explicitly switch to that track
+         timeout.Set();
+         break;
+    case kNone: break;
+    default: if ((Key & k_Release) == 0)
+                return osEnd;
+    }
+  if (track != oldTrack) {
+     Show();
+     cDevice::PrimaryDevice()->SetCurrentSubtitleTrack(types[track], true);
+     }
+  return timeout.TimedOut() ? osEnd : osContinue;
+}
+
 // --- cRecordControl --------------------------------------------------------
 
 cRecordControl::cRecordControl(cDevice *Device, cTimer *Timer, bool Pause)
diff -ruN vdr-1.5.9/menu.h vdr-1.5.10/menu.h
--- vdr-1.5.9/menu.h	2007-08-12 12:35:42.000000000 +0200
+++ vdr-1.5.10/menu.h	2007-08-26 16:35:57.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 1.88 2007/08/12 10:35:42 kls Exp $
+ * $Id: menu.h 1.89 2007/08/26 14:35:57 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -128,6 +128,24 @@
   eOSState ProcessKey(eKeys Key);
   };
 
+class cDisplaySubtitleTracks : public cOsdObject {
+private:
+  cSkinDisplayTracks *displayTracks;
+  cTimeMs timeout;
+  eTrackType types[ttMaxTrackTypes];
+  char *descriptions[ttMaxTrackTypes + 1]; // list is NULL terminated
+  int numTracks, track;
+  static cDisplaySubtitleTracks *currentDisplayTracks;
+  virtual void Show(void);
+  cDisplaySubtitleTracks(void);
+public:
+  virtual ~cDisplaySubtitleTracks();
+  static bool IsOpen(void) { return currentDisplayTracks != NULL; }
+  static cDisplaySubtitleTracks *Create(void);
+  static void Process(eKeys Key);
+  eOSState ProcessKey(eKeys Key);
+  };
+
 cOsdObject *CamControl(void);
 
 class cMenuRecordingItem;
diff -ruN vdr-1.5.9/menuitems.c vdr-1.5.10/menuitems.c
--- vdr-1.5.9/menuitems.c	2007-08-17 15:48:07.000000000 +0200
+++ vdr-1.5.10/menuitems.c	2007-10-13 14:05:37.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 1.51 2007/08/17 13:48:07 kls Exp $
+ * $Id: menuitems.c 1.53 2007/10/13 12:05:37 kls Exp $
  */
 
 #include "menuitems.h"
@@ -302,11 +302,11 @@
         stripspace(value);
         }
      lengthUtf8 = 0;
-     delete valueUtf8;
+     delete[] valueUtf8;
      valueUtf8 = NULL;
-     delete allowedUtf8;
+     delete[] allowedUtf8;
      allowedUtf8 = NULL;
-     delete charMapUtf8;
+     delete[] charMapUtf8;
      charMapUtf8 = NULL;
      pos = -1;
      offset = 0;
@@ -499,9 +499,9 @@
                     if (!insert || newchar)
                        pos--;
                     newchar = true;
+                    if (!insert && Utf8is(alpha, valueUtf8[pos]))
+                       uppercase = Utf8is(upper, valueUtf8[pos]);
                     }
-                 if (!insert && Utf8is(alpha, valueUtf8[pos]))
-                    uppercase = Utf8is(upper, valueUtf8[pos]);
                  break;
     case kRight|k_Repeat:
     case kRight: if (InEditMode())
diff -ruN vdr-1.5.9/newplugin vdr-1.5.10/newplugin
--- vdr-1.5.9/newplugin	2007-08-19 16:19:49.000000000 +0200
+++ vdr-1.5.10/newplugin	2007-10-14 11:13:17.000000000 +0200
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 1.36 2007/08/19 14:19:49 kls Exp $
+# $Id: newplugin 1.38 2007/10/14 09:13:17 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -139,12 +139,12 @@
 	msgfmt -c -o \$\@ \$<
 
 \$(I18Npot): \$(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<see README>' -o \$\@ \$(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<see README>' -o \$\@ \$(wildcard *.c)
 
 \$(I18Npo): \$(I18Npot)
-	msgmerge -U --no-wrap -F --backup=none -q \$\@ \$<
+	msgmerge -U --no-wrap --no-location --backup=none -q \$\@ \$<
 
-i18n: \$(I18Nmo)
+i18n: \$(I18Npot) \$(I18Nmo)
 	\@mkdir -p \$(LOCALEDIR)
 	for i in \$(I18Ndirs); do\\
 	    mkdir -p \$(LOCALEDIR)/\$\$i/LC_MESSAGES;\\
diff -ruN vdr-1.5.9/osd.c vdr-1.5.10/osd.c
--- vdr-1.5.9/osd.c	2007-08-26 11:44:50.000000000 +0200
+++ vdr-1.5.10/osd.c	2007-10-12 14:38:36.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.74 2007/08/26 09:44:50 kls Exp $
+ * $Id: osd.c 1.75 2007/10/12 12:38:36 kls Exp $
  */
 
 #include "osd.h"
@@ -82,7 +82,7 @@
      }
 }
 
-const tColor *cPalette::Colors(int &NumColors)
+const tColor *cPalette::Colors(int &NumColors) const
 {
   NumColors = numColors;
   return numColors ? color : NULL;
@@ -112,7 +112,7 @@
   antiAliasGranularity = Palette.antiAliasGranularity;
 }
 
-tColor cPalette::Blend(tColor ColorFg, tColor ColorBg, uint8_t Level)
+tColor cPalette::Blend(tColor ColorFg, tColor ColorBg, uint8_t Level) const
 {
   if (antiAliasGranularity > 0)
      Level = uint8_t(int(Level / antiAliasGranularity + 0.5) * antiAliasGranularity);
@@ -131,7 +131,7 @@
   return (A << 24) | (R << 16) | (G << 8) | B;
 }
 
-int cPalette::ClosestColor(tColor Color, int MaxDiff)
+int cPalette::ClosestColor(tColor Color, int MaxDiff) const
 {
   int n = 0;
   int d = INT_MAX;
@@ -640,6 +640,79 @@
   return &bitmap[y * width + x];
 }
 
+void cBitmap::ReduceBpp(const cPalette &Palette)
+{
+  int NewBpp = Palette.Bpp();
+  if (Bpp() == 4 && NewBpp == 2) {
+     for (int i = width * height; i--; ) {
+         tIndex p = bitmap[i];
+         bitmap[i] = (p >> 2) | ((p & 0x03) != 0);
+         }
+     }
+  else if (Bpp() == 8) {
+     if (NewBpp == 2) {
+        for (int i = width * height; i--; ) {
+            tIndex p = bitmap[i];
+            bitmap[i] = (p >> 6) | ((p & 0x30) != 0);
+            }
+        }
+     else if (NewBpp == 4) {
+        for (int i = width * height; i--; ) {
+            tIndex p = bitmap[i];
+            bitmap[i] = p >> 4;
+            }
+        }
+     else
+        return;
+     }
+  else
+     return;
+  SetBpp(NewBpp);
+  Replace(Palette);
+}
+
+void cBitmap::ShrinkBpp(int NewBpp)
+{
+  int NumOldColors;
+  const tColor *Colors = this->Colors(NumOldColors);
+  if (Colors) {
+     // Find the most frequently used colors and create a map table:
+     int Used[MAXNUMCOLORS] = { 0 };
+     int Map[MAXNUMCOLORS] = { 0 };
+     for (int i = width * height; i--; )
+         Used[bitmap[i]]++;
+     int MaxNewColors = (NewBpp == 4) ? 16 : 4;
+     cPalette NewPalette(NewBpp);
+     for (int i = 0; i < MaxNewColors; i++) {
+         int Max = 0;
+         int Index = -1;
+         for (int n = 0; n < NumOldColors; n++) {
+             if (Used[n] > Max) {
+                Max = Used[n];
+                Index = n;
+                }
+             }
+         if (Index >= 0) {
+            Used[Index] = 0;
+            Map[Index] = i;
+            NewPalette.SetColor(i, Colors[Index]);
+            }
+         else
+            break;
+         }
+     // Complete the map table for all other colors (will be set to closest match):
+     for (int n = 0; n < NumOldColors; n++) {
+         if (Used[n])
+            Map[n] = NewPalette.Index(Colors[n]);
+         }
+     // Do the actual index mapping:
+     for (int i = width * height; i--; )
+         bitmap[i] = Map[bitmap[i]];
+     SetBpp(NewBpp);
+     Replace(NewPalette);
+     }
+}
+
 // --- cOsd ------------------------------------------------------------------
 
 int cOsd::osdLeft = 0;
@@ -720,19 +793,18 @@
 
 eOsdError cOsd::SetAreas(const tArea *Areas, int NumAreas)
 {
-  eOsdError Result = oeUnknown;
-  if (numBitmaps == 0) {
-     Result = CanHandleAreas(Areas, NumAreas);
-     if (Result == oeOk) {
-        width = height = 0;
-        for (int i = 0; i < NumAreas; i++) {
-            bitmaps[numBitmaps++] = new cBitmap(Areas[i].Width(), Areas[i].Height(), Areas[i].bpp, Areas[i].x1, Areas[i].y1);
-            width = max(width, Areas[i].x2 + 1);
-            height = max(height, Areas[i].y2 + 1);
-            }
-        }
+  eOsdError Result = CanHandleAreas(Areas, NumAreas);
+  if (Result == oeOk) {
+     while (numBitmaps)
+           delete bitmaps[--numBitmaps];
+     width = height = 0;
+     for (int i = 0; i < NumAreas; i++) {
+         bitmaps[numBitmaps++] = new cBitmap(Areas[i].Width(), Areas[i].Height(), Areas[i].bpp, Areas[i].x1, Areas[i].y1);
+         width = max(width, Areas[i].x2 + 1);
+         height = max(height, Areas[i].y2 + 1);
+         }
      }
-  if (Result != oeOk)
+  else
      esyslog("ERROR: cOsd::SetAreas returned %d", Result);
   return Result;
 }
@@ -818,7 +890,7 @@
 
 cOsd *cOsdProvider::NewOsd(int Left, int Top, uint Level)
 {
-  if (Level == 0 && cOsd::IsOpen())
+  if (Level == OSD_LEVEL_DEFAULT && cOsd::IsOpen())
      esyslog("ERROR: attempt to open OSD while it is already open - using dummy OSD!");
   else if (osdProvider) {
      cOsd *ActiveOsd = cOsd::Osds.Size() ? cOsd::Osds[0] : NULL;
diff -ruN vdr-1.5.9/osd.h vdr-1.5.10/osd.h
--- vdr-1.5.9/osd.h	2007-08-26 11:45:38.000000000 +0200
+++ vdr-1.5.10/osd.h	2007-10-12 16:28:44.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.h 1.57 2007/08/26 09:45:38 kls Exp $
+ * $Id: osd.h 1.58 2007/10/12 14:28:44 kls Exp $
  */
 
 #ifndef __OSD_H
@@ -17,6 +17,9 @@
 #include "font.h"
 #include "tools.h"
 
+#define OSD_LEVEL_DEFAULT     0
+#define OSD_LEVEL_SUBTITLES  10
+
 #define MAXNUMCOLORS 256
 
 enum {
@@ -69,7 +72,7 @@
         ///< a single color combination, and may not be able to serve all
         ///< requested colors. By default the palette assumes there will be
         ///< 10 fixed colors and 10 color combinations.
-  int Bpp(void) { return bpp; }
+  int Bpp(void) const { return bpp; }
   void Reset(void);
         ///< Resets the palette, making it contain no colors.
   int Index(tColor Color);
@@ -77,7 +80,7 @@
         ///< If Color is not yet contained in this palette, it will be added if
         ///< there is a free slot. If the color can't be added to this palette,
         ///< the closest existing color will be returned.
-  tColor Color(int Index) { return Index < maxColors ? color[Index] : 0; }
+  tColor Color(int Index) const { return Index < maxColors ? color[Index] : 0; }
         ///< Returns the color at the given Index. If Index is outside the valid
         ///< range, 0 will be returned.
   void SetBpp(int Bpp);
@@ -87,7 +90,7 @@
         ///< Sets the palette entry at Index to Color. If Index is larger than
         ///< the number of currently used entries in this palette, the entries
         ///< in between will have undefined values.
-  const tColor *Colors(int &NumColors);
+  const tColor *Colors(int &NumColors) const;
         ///< Returns a pointer to the complete color table and stores the
         ///< number of valid entries in NumColors. If no colors have been
         ///< stored yet, NumColors will be set to 0 and the function will
@@ -102,14 +105,14 @@
   void Replace(const cPalette &Palette);
         ///< Replaces the colors of this palette with the colors from the given
         ///< palette.
-  tColor Blend(tColor ColorFg, tColor ColorBg, uint8_t Level);
+  tColor Blend(tColor ColorFg, tColor ColorBg, uint8_t Level) const;
         ///< Determines a color that consists of a linear blend between ColorFg
         ///< and ColorBg. If Level is 0, the result is ColorBg, if it is 255,
         ///< the result is ColorFg. If SetAntiAliasGranularity() has been called previously,
         ///< Level will be mapped to a limited range of levels that allow to make best
         ///< use of the palette entries.
-  int ClosestColor(tColor Color, int MaxDiff = INT_MAX);
-        ///< Returns the index of a color in this paltte that is closest to the given
+  int ClosestColor(tColor Color, int MaxDiff = INT_MAX) const;
+        ///< Returns the index of a color in this palette that is closest to the given
         ///< Color. MaxDiff can be used to control the maximum allowed color difference.
         ///< If no color with a maximum difference of MaxDiff can be found, -1 will
         ///< be returned. With the default value of INT_MAX, there will always be
@@ -232,6 +235,17 @@
        ///< Returns the address of the index byte at the given coordinates.
   tColor GetColor(int x, int y) { return Color(*Data(x, y)); }
        ///< Returns the color at the given coordinates.
+  void ReduceBpp(const cPalette &Palette);
+       ///< Reduces the color depth of the bitmap to that of the given Palette.
+       ///< If Palette's color depth is not smaller than the bitmap's current
+       ///< color depth, or if it is not one of 4bpp or 2bpp, nothing happens. After
+       ///< reducing the color depth the current palette is replaced with
+       ///< the given one.
+  void ShrinkBpp(int NewBpp);
+       ///< Shrinks the color depth of the bitmap to NewBpp by keeping only
+       ///< the 2^NewBpp most frequently used colors as defined in the current palette.
+       ///< If NewBpp is not smaller than the bitmap's current color depth,
+       ///< or if it is not one of 4bpp or 2bpp, nothing happens.
   };
 
 struct tArea {
@@ -292,7 +306,7 @@
        ///< This may be useful for plugins that determine the scaling of the
        ///< video image and need to scale the OSD accordingly to fit on the
        ///< screen.
-  static int IsOpen(void) { return Osds.Size() && Osds[0]->level == 0; }
+  static int IsOpen(void) { return Osds.Size() && Osds[0]->level == OSD_LEVEL_DEFAULT; }
        ///< Returns true if there is currently a level 0 OSD open.
   int Left(void) { return left; }
   int Top(void) { return top; }
@@ -327,6 +341,7 @@
        ///< If the OSD has been divided into several sub-areas, all areas that
        ///< are part of the rectangle that surrounds a given drawing operation
        ///< will be drawn into, with the proper offsets.
+       ///< A new call overwrites any previous settings
   virtual void SaveRegion(int x1, int y1, int x2, int y2);
        ///< Saves the region defined by the given coordinates for later restoration
        ///< through RestoreRegion(). Only one saved region can be active at any
@@ -398,7 +413,7 @@
   cOsdProvider(void);
       //XXX maybe parameter to make this one "sticky"??? (frame-buffer etc.)
   virtual ~cOsdProvider();
-  static cOsd *NewOsd(int Left, int Top, uint Level = 0);
+  static cOsd *NewOsd(int Left, int Top, uint Level = OSD_LEVEL_DEFAULT);
       ///< Returns a pointer to a newly created cOsd object, which will be located
       ///< at the given coordinates. When the cOsd object is no longer needed, the
       ///< caller must delete it. If the OSD is already in use, or there is no OSD
